// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from kompass_interfaces:action/TrackPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__BUILDER_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "kompass_interfaces/action/detail/track_path__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackPath_Goal_follow_path
{
public:
  explicit Init_TrackPath_Goal_follow_path(::kompass_interfaces::action::TrackPath_Goal & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackPath_Goal follow_path(::kompass_interfaces::action::TrackPath_Goal::_follow_path_type arg)
  {
    msg_.follow_path = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_Goal msg_;
};

class Init_TrackPath_Goal_time_step
{
public:
  explicit Init_TrackPath_Goal_time_step(::kompass_interfaces::action::TrackPath_Goal & msg)
  : msg_(msg)
  {}
  Init_TrackPath_Goal_follow_path time_step(::kompass_interfaces::action::TrackPath_Goal::_time_step_type arg)
  {
    msg_.time_step = std::move(arg);
    return Init_TrackPath_Goal_follow_path(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_Goal msg_;
};

class Init_TrackPath_Goal_number_of_cmds
{
public:
  Init_TrackPath_Goal_number_of_cmds()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackPath_Goal_time_step number_of_cmds(::kompass_interfaces::action::TrackPath_Goal::_number_of_cmds_type arg)
  {
    msg_.number_of_cmds = std::move(arg);
    return Init_TrackPath_Goal_time_step(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_Goal msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackPath_Goal>()
{
  return kompass_interfaces::action::builder::Init_TrackPath_Goal_number_of_cmds();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackPath_Result_tracking_error
{
public:
  explicit Init_TrackPath_Result_tracking_error(::kompass_interfaces::action::TrackPath_Result & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackPath_Result tracking_error(::kompass_interfaces::action::TrackPath_Result::_tracking_error_type arg)
  {
    msg_.tracking_error = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_Result msg_;
};

class Init_TrackPath_Result_reached_end
{
public:
  Init_TrackPath_Result_reached_end()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackPath_Result_tracking_error reached_end(::kompass_interfaces::action::TrackPath_Result::_reached_end_type arg)
  {
    msg_.reached_end = std::move(arg);
    return Init_TrackPath_Result_tracking_error(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_Result msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackPath_Result>()
{
  return kompass_interfaces::action::builder::Init_TrackPath_Result_reached_end();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackPath_Feedback_tracking_errors
{
public:
  explicit Init_TrackPath_Feedback_tracking_errors(::kompass_interfaces::action::TrackPath_Feedback & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackPath_Feedback tracking_errors(::kompass_interfaces::action::TrackPath_Feedback::_tracking_errors_type arg)
  {
    msg_.tracking_errors = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_Feedback msg_;
};

class Init_TrackPath_Feedback_global_path
{
public:
  explicit Init_TrackPath_Feedback_global_path(::kompass_interfaces::action::TrackPath_Feedback & msg)
  : msg_(msg)
  {}
  Init_TrackPath_Feedback_tracking_errors global_path(::kompass_interfaces::action::TrackPath_Feedback::_global_path_type arg)
  {
    msg_.global_path = std::move(arg);
    return Init_TrackPath_Feedback_tracking_errors(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_Feedback msg_;
};

class Init_TrackPath_Feedback_cmd_list
{
public:
  Init_TrackPath_Feedback_cmd_list()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackPath_Feedback_global_path cmd_list(::kompass_interfaces::action::TrackPath_Feedback::_cmd_list_type arg)
  {
    msg_.cmd_list = std::move(arg);
    return Init_TrackPath_Feedback_global_path(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_Feedback msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackPath_Feedback>()
{
  return kompass_interfaces::action::builder::Init_TrackPath_Feedback_cmd_list();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackPath_SendGoal_Request_goal
{
public:
  explicit Init_TrackPath_SendGoal_Request_goal(::kompass_interfaces::action::TrackPath_SendGoal_Request & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackPath_SendGoal_Request goal(::kompass_interfaces::action::TrackPath_SendGoal_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_SendGoal_Request msg_;
};

class Init_TrackPath_SendGoal_Request_goal_id
{
public:
  Init_TrackPath_SendGoal_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackPath_SendGoal_Request_goal goal_id(::kompass_interfaces::action::TrackPath_SendGoal_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_TrackPath_SendGoal_Request_goal(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_SendGoal_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackPath_SendGoal_Request>()
{
  return kompass_interfaces::action::builder::Init_TrackPath_SendGoal_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackPath_SendGoal_Response_stamp
{
public:
  explicit Init_TrackPath_SendGoal_Response_stamp(::kompass_interfaces::action::TrackPath_SendGoal_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackPath_SendGoal_Response stamp(::kompass_interfaces::action::TrackPath_SendGoal_Response::_stamp_type arg)
  {
    msg_.stamp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_SendGoal_Response msg_;
};

class Init_TrackPath_SendGoal_Response_accepted
{
public:
  Init_TrackPath_SendGoal_Response_accepted()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackPath_SendGoal_Response_stamp accepted(::kompass_interfaces::action::TrackPath_SendGoal_Response::_accepted_type arg)
  {
    msg_.accepted = std::move(arg);
    return Init_TrackPath_SendGoal_Response_stamp(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_SendGoal_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackPath_SendGoal_Response>()
{
  return kompass_interfaces::action::builder::Init_TrackPath_SendGoal_Response_accepted();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackPath_GetResult_Request_goal_id
{
public:
  Init_TrackPath_GetResult_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::kompass_interfaces::action::TrackPath_GetResult_Request goal_id(::kompass_interfaces::action::TrackPath_GetResult_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_GetResult_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackPath_GetResult_Request>()
{
  return kompass_interfaces::action::builder::Init_TrackPath_GetResult_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackPath_GetResult_Response_result
{
public:
  explicit Init_TrackPath_GetResult_Response_result(::kompass_interfaces::action::TrackPath_GetResult_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackPath_GetResult_Response result(::kompass_interfaces::action::TrackPath_GetResult_Response::_result_type arg)
  {
    msg_.result = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_GetResult_Response msg_;
};

class Init_TrackPath_GetResult_Response_status
{
public:
  Init_TrackPath_GetResult_Response_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackPath_GetResult_Response_result status(::kompass_interfaces::action::TrackPath_GetResult_Response::_status_type arg)
  {
    msg_.status = std::move(arg);
    return Init_TrackPath_GetResult_Response_result(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_GetResult_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackPath_GetResult_Response>()
{
  return kompass_interfaces::action::builder::Init_TrackPath_GetResult_Response_status();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_TrackPath_FeedbackMessage_feedback
{
public:
  explicit Init_TrackPath_FeedbackMessage_feedback(::kompass_interfaces::action::TrackPath_FeedbackMessage & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::TrackPath_FeedbackMessage feedback(::kompass_interfaces::action::TrackPath_FeedbackMessage::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_FeedbackMessage msg_;
};

class Init_TrackPath_FeedbackMessage_goal_id
{
public:
  Init_TrackPath_FeedbackMessage_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_TrackPath_FeedbackMessage_feedback goal_id(::kompass_interfaces::action::TrackPath_FeedbackMessage::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_TrackPath_FeedbackMessage_feedback(msg_);
  }

private:
  ::kompass_interfaces::action::TrackPath_FeedbackMessage msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::TrackPath_FeedbackMessage>()
{
  return kompass_interfaces::action::builder::Init_TrackPath_FeedbackMessage_goal_id();
}

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__BUILDER_HPP_
