// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:msg/PredictedOccupancies.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__PREDICTED_OCCUPANCIES__STRUCT_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__PREDICTED_OCCUPANCIES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'obstacles'
#include "kompass_interfaces/msg/detail/obstacles__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__msg__PredictedOccupancies __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__msg__PredictedOccupancies __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PredictedOccupancies_
{
  using Type = PredictedOccupancies_<ContainerAllocator>;

  explicit PredictedOccupancies_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->start_time = 0.0f;
      this->horizon = 0.0f;
      this->time_step = 0.0f;
    }
  }

  explicit PredictedOccupancies_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->start_time = 0.0f;
      this->horizon = 0.0f;
      this->time_step = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _start_time_type =
    float;
  _start_time_type start_time;
  using _horizon_type =
    float;
  _horizon_type horizon;
  using _time_step_type =
    float;
  _time_step_type time_step;
  using _obstacles_type =
    std::vector<kompass_interfaces::msg::Obstacles_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<kompass_interfaces::msg::Obstacles_<ContainerAllocator>>>;
  _obstacles_type obstacles;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__start_time(
    const float & _arg)
  {
    this->start_time = _arg;
    return *this;
  }
  Type & set__horizon(
    const float & _arg)
  {
    this->horizon = _arg;
    return *this;
  }
  Type & set__time_step(
    const float & _arg)
  {
    this->time_step = _arg;
    return *this;
  }
  Type & set__obstacles(
    const std::vector<kompass_interfaces::msg::Obstacles_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<kompass_interfaces::msg::Obstacles_<ContainerAllocator>>> & _arg)
  {
    this->obstacles = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__msg__PredictedOccupancies
    std::shared_ptr<kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__msg__PredictedOccupancies
    std::shared_ptr<kompass_interfaces::msg::PredictedOccupancies_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PredictedOccupancies_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->start_time != other.start_time) {
      return false;
    }
    if (this->horizon != other.horizon) {
      return false;
    }
    if (this->time_step != other.time_step) {
      return false;
    }
    if (this->obstacles != other.obstacles) {
      return false;
    }
    return true;
  }
  bool operator!=(const PredictedOccupancies_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PredictedOccupancies_

// alias to use template instance with default allocator
using PredictedOccupancies =
  kompass_interfaces::msg::PredictedOccupancies_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__PREDICTED_OCCUPANCIES__STRUCT_HPP_
