// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:msg/TwistArray.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__TWIST_ARRAY__STRUCT_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__TWIST_ARRAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'linear_velocities'
// Member 'angular_velocities'
#include "kompass_interfaces/msg/detail/vector_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__msg__TwistArray __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__msg__TwistArray __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TwistArray_
{
  using Type = TwistArray_<ContainerAllocator>;

  explicit TwistArray_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : linear_velocities(_init),
    angular_velocities(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_step = 0.0f;
    }
  }

  explicit TwistArray_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : linear_velocities(_alloc, _init),
    angular_velocities(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_step = 0.0f;
    }
  }

  // field types and members
  using _linear_velocities_type =
    kompass_interfaces::msg::VectorArray_<ContainerAllocator>;
  _linear_velocities_type linear_velocities;
  using _angular_velocities_type =
    kompass_interfaces::msg::VectorArray_<ContainerAllocator>;
  _angular_velocities_type angular_velocities;
  using _time_step_type =
    float;
  _time_step_type time_step;

  // setters for named parameter idiom
  Type & set__linear_velocities(
    const kompass_interfaces::msg::VectorArray_<ContainerAllocator> & _arg)
  {
    this->linear_velocities = _arg;
    return *this;
  }
  Type & set__angular_velocities(
    const kompass_interfaces::msg::VectorArray_<ContainerAllocator> & _arg)
  {
    this->angular_velocities = _arg;
    return *this;
  }
  Type & set__time_step(
    const float & _arg)
  {
    this->time_step = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::msg::TwistArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::msg::TwistArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::msg::TwistArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::msg::TwistArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::TwistArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::TwistArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::TwistArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::TwistArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::msg::TwistArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::msg::TwistArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__msg__TwistArray
    std::shared_ptr<kompass_interfaces::msg::TwistArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__msg__TwistArray
    std::shared_ptr<kompass_interfaces::msg::TwistArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TwistArray_ & other) const
  {
    if (this->linear_velocities != other.linear_velocities) {
      return false;
    }
    if (this->angular_velocities != other.angular_velocities) {
      return false;
    }
    if (this->time_step != other.time_step) {
      return false;
    }
    return true;
  }
  bool operator!=(const TwistArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TwistArray_

// alias to use template instance with default allocator
using TwistArray =
  kompass_interfaces::msg::TwistArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__TWIST_ARRAY__STRUCT_HPP_
