// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:srv/StartPathRecording.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__STRUCT_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__StartPathRecording_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__StartPathRecording_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct StartPathRecording_Request_
{
  using Type = StartPathRecording_Request_<ContainerAllocator>;

  explicit StartPathRecording_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->recording_time_step = 0.0;
    }
  }

  explicit StartPathRecording_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->recording_time_step = 0.0;
    }
  }

  // field types and members
  using _recording_time_step_type =
    double;
  _recording_time_step_type recording_time_step;

  // setters for named parameter idiom
  Type & set__recording_time_step(
    const double & _arg)
  {
    this->recording_time_step = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__StartPathRecording_Request
    std::shared_ptr<kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__StartPathRecording_Request
    std::shared_ptr<kompass_interfaces::srv::StartPathRecording_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StartPathRecording_Request_ & other) const
  {
    if (this->recording_time_step != other.recording_time_step) {
      return false;
    }
    return true;
  }
  bool operator!=(const StartPathRecording_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StartPathRecording_Request_

// alias to use template instance with default allocator
using StartPathRecording_Request =
  kompass_interfaces::srv::StartPathRecording_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__StartPathRecording_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__StartPathRecording_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct StartPathRecording_Response_
{
  using Type = StartPathRecording_Response_<ContainerAllocator>;

  explicit StartPathRecording_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->started_recording = false;
      this->message = "";
    }
  }

  explicit StartPathRecording_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->started_recording = false;
      this->message = "";
    }
  }

  // field types and members
  using _started_recording_type =
    bool;
  _started_recording_type started_recording;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__started_recording(
    const bool & _arg)
  {
    this->started_recording = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__StartPathRecording_Response
    std::shared_ptr<kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__StartPathRecording_Response
    std::shared_ptr<kompass_interfaces::srv::StartPathRecording_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StartPathRecording_Response_ & other) const
  {
    if (this->started_recording != other.started_recording) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const StartPathRecording_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StartPathRecording_Response_

// alias to use template instance with default allocator
using StartPathRecording_Response =
  kompass_interfaces::srv::StartPathRecording_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace srv
{

struct StartPathRecording
{
  using Request = kompass_interfaces::srv::StartPathRecording_Request;
  using Response = kompass_interfaces::srv::StartPathRecording_Response;
};

}  // namespace srv

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__STRUCT_HPP_
