// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:srv/StopVisionTracking.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__STOP_VISION_TRACKING__TRAITS_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__STOP_VISION_TRACKING__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/srv/detail/stop_vision_tracking__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StopVisionTracking_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: label
  {
    out << "label: ";
    rosidl_generator_traits::value_to_yaml(msg.label, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StopVisionTracking_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: label
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "label: ";
    rosidl_generator_traits::value_to_yaml(msg.label, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StopVisionTracking_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::StopVisionTracking_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::StopVisionTracking_Request & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::StopVisionTracking_Request>()
{
  return "kompass_interfaces::srv::StopVisionTracking_Request";
}

template<>
inline const char * name<kompass_interfaces::srv::StopVisionTracking_Request>()
{
  return "kompass_interfaces/srv/StopVisionTracking_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StopVisionTracking_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::StopVisionTracking_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::srv::StopVisionTracking_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StopVisionTracking_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StopVisionTracking_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StopVisionTracking_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::StopVisionTracking_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::StopVisionTracking_Response & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::StopVisionTracking_Response>()
{
  return "kompass_interfaces::srv::StopVisionTracking_Response";
}

template<>
inline const char * name<kompass_interfaces::srv::StopVisionTracking_Response>()
{
  return "kompass_interfaces/srv/StopVisionTracking_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StopVisionTracking_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::StopVisionTracking_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<kompass_interfaces::srv::StopVisionTracking_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::StopVisionTracking>()
{
  return "kompass_interfaces::srv::StopVisionTracking";
}

template<>
inline const char * name<kompass_interfaces::srv::StopVisionTracking>()
{
  return "kompass_interfaces/srv/StopVisionTracking";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StopVisionTracking>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::srv::StopVisionTracking_Request>::value &&
    has_fixed_size<kompass_interfaces::srv::StopVisionTracking_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::srv::StopVisionTracking>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::srv::StopVisionTracking_Request>::value &&
    has_bounded_size<kompass_interfaces::srv::StopVisionTracking_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::srv::StopVisionTracking>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::srv::StopVisionTracking_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::srv::StopVisionTracking_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__STOP_VISION_TRACKING__TRAITS_HPP_
