// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:action/ControlPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__STRUCT_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__ControlPath_Goal __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__ControlPath_Goal __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ControlPath_Goal_
{
  using Type = ControlPath_Goal_<ContainerAllocator>;

  explicit ControlPath_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_source = 0l;
      this->path_name = "";
      this->path_file_location = "";
      this->controller = 0l;
    }
  }

  explicit ControlPath_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path_name(_alloc),
    path_file_location(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_source = 0l;
      this->path_name = "";
      this->path_file_location = "";
      this->controller = 0l;
    }
  }

  // field types and members
  using _path_source_type =
    int32_t;
  _path_source_type path_source;
  using _path_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _path_name_type path_name;
  using _path_file_location_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _path_file_location_type path_file_location;
  using _controller_type =
    int32_t;
  _controller_type controller;

  // setters for named parameter idiom
  Type & set__path_source(
    const int32_t & _arg)
  {
    this->path_source = _arg;
    return *this;
  }
  Type & set__path_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->path_name = _arg;
    return *this;
  }
  Type & set__path_file_location(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->path_file_location = _arg;
    return *this;
  }
  Type & set__controller(
    const int32_t & _arg)
  {
    this->controller = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_Goal
    std::shared_ptr<kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_Goal
    std::shared_ptr<kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlPath_Goal_ & other) const
  {
    if (this->path_source != other.path_source) {
      return false;
    }
    if (this->path_name != other.path_name) {
      return false;
    }
    if (this->path_file_location != other.path_file_location) {
      return false;
    }
    if (this->controller != other.controller) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlPath_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlPath_Goal_

// alias to use template instance with default allocator
using ControlPath_Goal =
  kompass_interfaces::action::ControlPath_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'destination_error'
#include "kompass_interfaces/msg/detail/path_tracking_error__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__ControlPath_Result __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__ControlPath_Result __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ControlPath_Result_
{
  using Type = ControlPath_Result_<ContainerAllocator>;

  explicit ControlPath_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : destination_error(_init)
  {
    (void)_init;
  }

  explicit ControlPath_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : destination_error(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _destination_error_type =
    kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>;
  _destination_error_type destination_error;

  // setters for named parameter idiom
  Type & set__destination_error(
    const kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> & _arg)
  {
    this->destination_error = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::ControlPath_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::ControlPath_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_Result
    std::shared_ptr<kompass_interfaces::action::ControlPath_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_Result
    std::shared_ptr<kompass_interfaces::action::ControlPath_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlPath_Result_ & other) const
  {
    if (this->destination_error != other.destination_error) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlPath_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlPath_Result_

// alias to use template instance with default allocator
using ControlPath_Result =
  kompass_interfaces::action::ControlPath_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'global_path_deviation'
// already included above
// #include "kompass_interfaces/msg/detail/path_tracking_error__struct.hpp"
// Member 'control'
#include "geometry_msgs/msg/detail/twist__struct.hpp"
// Member 'control_list'
#include "kompass_interfaces/msg/detail/twist_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__ControlPath_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__ControlPath_Feedback __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ControlPath_Feedback_
{
  using Type = ControlPath_Feedback_<ContainerAllocator>;

  explicit ControlPath_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : global_path_deviation(_init),
    control(_init),
    control_list(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->prediction_horizon = 0.0;
      this->compute_time = 0.0;
    }
  }

  explicit ControlPath_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : global_path_deviation(_alloc, _init),
    control(_alloc, _init),
    control_list(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->prediction_horizon = 0.0;
      this->compute_time = 0.0;
    }
  }

  // field types and members
  using _global_path_deviation_type =
    kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>;
  _global_path_deviation_type global_path_deviation;
  using _prediction_horizon_type =
    double;
  _prediction_horizon_type prediction_horizon;
  using _compute_time_type =
    double;
  _compute_time_type compute_time;
  using _control_type =
    geometry_msgs::msg::Twist_<ContainerAllocator>;
  _control_type control;
  using _control_list_type =
    kompass_interfaces::msg::TwistArray_<ContainerAllocator>;
  _control_list_type control_list;

  // setters for named parameter idiom
  Type & set__global_path_deviation(
    const kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> & _arg)
  {
    this->global_path_deviation = _arg;
    return *this;
  }
  Type & set__prediction_horizon(
    const double & _arg)
  {
    this->prediction_horizon = _arg;
    return *this;
  }
  Type & set__compute_time(
    const double & _arg)
  {
    this->compute_time = _arg;
    return *this;
  }
  Type & set__control(
    const geometry_msgs::msg::Twist_<ContainerAllocator> & _arg)
  {
    this->control = _arg;
    return *this;
  }
  Type & set__control_list(
    const kompass_interfaces::msg::TwistArray_<ContainerAllocator> & _arg)
  {
    this->control_list = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_Feedback
    std::shared_ptr<kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_Feedback
    std::shared_ptr<kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlPath_Feedback_ & other) const
  {
    if (this->global_path_deviation != other.global_path_deviation) {
      return false;
    }
    if (this->prediction_horizon != other.prediction_horizon) {
      return false;
    }
    if (this->compute_time != other.compute_time) {
      return false;
    }
    if (this->control != other.control) {
      return false;
    }
    if (this->control_list != other.control_list) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlPath_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlPath_Feedback_

// alias to use template instance with default allocator
using ControlPath_Feedback =
  kompass_interfaces::action::ControlPath_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "kompass_interfaces/action/detail/control_path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__ControlPath_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__ControlPath_SendGoal_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ControlPath_SendGoal_Request_
{
  using Type = ControlPath_SendGoal_Request_<ContainerAllocator>;

  explicit ControlPath_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit ControlPath_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const kompass_interfaces::action::ControlPath_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_SendGoal_Request
    std::shared_ptr<kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_SendGoal_Request
    std::shared_ptr<kompass_interfaces::action::ControlPath_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlPath_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlPath_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlPath_SendGoal_Request_

// alias to use template instance with default allocator
using ControlPath_SendGoal_Request =
  kompass_interfaces::action::ControlPath_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__ControlPath_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__ControlPath_SendGoal_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ControlPath_SendGoal_Response_
{
  using Type = ControlPath_SendGoal_Response_<ContainerAllocator>;

  explicit ControlPath_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit ControlPath_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_SendGoal_Response
    std::shared_ptr<kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_SendGoal_Response
    std::shared_ptr<kompass_interfaces::action::ControlPath_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlPath_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlPath_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlPath_SendGoal_Response_

// alias to use template instance with default allocator
using ControlPath_SendGoal_Response =
  kompass_interfaces::action::ControlPath_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace action
{

struct ControlPath_SendGoal
{
  using Request = kompass_interfaces::action::ControlPath_SendGoal_Request;
  using Response = kompass_interfaces::action::ControlPath_SendGoal_Response;
};

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__ControlPath_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__ControlPath_GetResult_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ControlPath_GetResult_Request_
{
  using Type = ControlPath_GetResult_Request_<ContainerAllocator>;

  explicit ControlPath_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit ControlPath_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_GetResult_Request
    std::shared_ptr<kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_GetResult_Request
    std::shared_ptr<kompass_interfaces::action::ControlPath_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlPath_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlPath_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlPath_GetResult_Request_

// alias to use template instance with default allocator
using ControlPath_GetResult_Request =
  kompass_interfaces::action::ControlPath_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/control_path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__ControlPath_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__ControlPath_GetResult_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ControlPath_GetResult_Response_
{
  using Type = ControlPath_GetResult_Response_<ContainerAllocator>;

  explicit ControlPath_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit ControlPath_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    kompass_interfaces::action::ControlPath_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const kompass_interfaces::action::ControlPath_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_GetResult_Response
    std::shared_ptr<kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_GetResult_Response
    std::shared_ptr<kompass_interfaces::action::ControlPath_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlPath_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlPath_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlPath_GetResult_Response_

// alias to use template instance with default allocator
using ControlPath_GetResult_Response =
  kompass_interfaces::action::ControlPath_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace action
{

struct ControlPath_GetResult
{
  using Request = kompass_interfaces::action::ControlPath_GetResult_Request;
  using Response = kompass_interfaces::action::ControlPath_GetResult_Response;
};

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/control_path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__ControlPath_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__ControlPath_FeedbackMessage __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ControlPath_FeedbackMessage_
{
  using Type = ControlPath_FeedbackMessage_<ContainerAllocator>;

  explicit ControlPath_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit ControlPath_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const kompass_interfaces::action::ControlPath_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_FeedbackMessage
    std::shared_ptr<kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__ControlPath_FeedbackMessage
    std::shared_ptr<kompass_interfaces::action::ControlPath_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlPath_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlPath_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlPath_FeedbackMessage_

// alias to use template instance with default allocator
using ControlPath_FeedbackMessage =
  kompass_interfaces::action::ControlPath_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace kompass_interfaces
{

namespace action
{

struct ControlPath
{
  /// The goal message defined in the action definition.
  using Goal = kompass_interfaces::action::ControlPath_Goal;
  /// The result message defined in the action definition.
  using Result = kompass_interfaces::action::ControlPath_Result;
  /// The feedback message defined in the action definition.
  using Feedback = kompass_interfaces::action::ControlPath_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = kompass_interfaces::action::ControlPath_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = kompass_interfaces::action::ControlPath_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = kompass_interfaces::action::ControlPath_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct ControlPath ControlPath;

}  // namespace action

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__CONTROL_PATH__STRUCT_HPP_
