// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:action/MotionRecording.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__STRUCT_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__MotionRecording_Goal __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__MotionRecording_Goal __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MotionRecording_Goal_
{
  using Type = MotionRecording_Goal_<ContainerAllocator>;

  explicit MotionRecording_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->recording_period_secs = 0.0;
      this->recording_time_step_secs = 0.0;
      this->csv_file_location = "";
      this->csv_file_name = "";
    }
  }

  explicit MotionRecording_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : csv_file_location(_alloc),
    csv_file_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->recording_period_secs = 0.0;
      this->recording_time_step_secs = 0.0;
      this->csv_file_location = "";
      this->csv_file_name = "";
    }
  }

  // field types and members
  using _recording_period_secs_type =
    double;
  _recording_period_secs_type recording_period_secs;
  using _recording_time_step_secs_type =
    double;
  _recording_time_step_secs_type recording_time_step_secs;
  using _csv_file_location_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _csv_file_location_type csv_file_location;
  using _csv_file_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _csv_file_name_type csv_file_name;

  // setters for named parameter idiom
  Type & set__recording_period_secs(
    const double & _arg)
  {
    this->recording_period_secs = _arg;
    return *this;
  }
  Type & set__recording_time_step_secs(
    const double & _arg)
  {
    this->recording_time_step_secs = _arg;
    return *this;
  }
  Type & set__csv_file_location(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->csv_file_location = _arg;
    return *this;
  }
  Type & set__csv_file_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->csv_file_name = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_Goal
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_Goal
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionRecording_Goal_ & other) const
  {
    if (this->recording_period_secs != other.recording_period_secs) {
      return false;
    }
    if (this->recording_time_step_secs != other.recording_time_step_secs) {
      return false;
    }
    if (this->csv_file_location != other.csv_file_location) {
      return false;
    }
    if (this->csv_file_name != other.csv_file_name) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionRecording_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionRecording_Goal_

// alias to use template instance with default allocator
using MotionRecording_Goal =
  kompass_interfaces::action::MotionRecording_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__MotionRecording_Result __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__MotionRecording_Result __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MotionRecording_Result_
{
  using Type = MotionRecording_Result_<ContainerAllocator>;

  explicit MotionRecording_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->recording_done = false;
      this->message = "";
    }
  }

  explicit MotionRecording_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->recording_done = false;
      this->message = "";
    }
  }

  // field types and members
  using _recording_done_type =
    bool;
  _recording_done_type recording_done;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__recording_done(
    const bool & _arg)
  {
    this->recording_done = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_Result
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_Result
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionRecording_Result_ & other) const
  {
    if (this->recording_done != other.recording_done) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionRecording_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionRecording_Result_

// alias to use template instance with default allocator
using MotionRecording_Result =
  kompass_interfaces::action::MotionRecording_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'position'
// Member 'cmd'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__MotionRecording_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__MotionRecording_Feedback __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MotionRecording_Feedback_
{
  using Type = MotionRecording_Feedback_<ContainerAllocator>;

  explicit MotionRecording_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : position(_init),
    cmd(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->heading = 0.0;
    }
  }

  explicit MotionRecording_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : position(_alloc, _init),
    cmd(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->heading = 0.0;
    }
  }

  // field types and members
  using _position_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _position_type position;
  using _heading_type =
    double;
  _heading_type heading;
  using _cmd_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _cmd_type cmd;

  // setters for named parameter idiom
  Type & set__position(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__heading(
    const double & _arg)
  {
    this->heading = _arg;
    return *this;
  }
  Type & set__cmd(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->cmd = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_Feedback
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_Feedback
    std::shared_ptr<kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionRecording_Feedback_ & other) const
  {
    if (this->position != other.position) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    if (this->cmd != other.cmd) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionRecording_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionRecording_Feedback_

// alias to use template instance with default allocator
using MotionRecording_Feedback =
  kompass_interfaces::action::MotionRecording_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "kompass_interfaces/action/detail/motion_recording__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__MotionRecording_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__MotionRecording_SendGoal_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MotionRecording_SendGoal_Request_
{
  using Type = MotionRecording_SendGoal_Request_<ContainerAllocator>;

  explicit MotionRecording_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit MotionRecording_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const kompass_interfaces::action::MotionRecording_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_SendGoal_Request
    std::shared_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_SendGoal_Request
    std::shared_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionRecording_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionRecording_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionRecording_SendGoal_Request_

// alias to use template instance with default allocator
using MotionRecording_SendGoal_Request =
  kompass_interfaces::action::MotionRecording_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__MotionRecording_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__MotionRecording_SendGoal_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MotionRecording_SendGoal_Response_
{
  using Type = MotionRecording_SendGoal_Response_<ContainerAllocator>;

  explicit MotionRecording_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit MotionRecording_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_SendGoal_Response
    std::shared_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_SendGoal_Response
    std::shared_ptr<kompass_interfaces::action::MotionRecording_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionRecording_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionRecording_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionRecording_SendGoal_Response_

// alias to use template instance with default allocator
using MotionRecording_SendGoal_Response =
  kompass_interfaces::action::MotionRecording_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace action
{

struct MotionRecording_SendGoal
{
  using Request = kompass_interfaces::action::MotionRecording_SendGoal_Request;
  using Response = kompass_interfaces::action::MotionRecording_SendGoal_Response;
};

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__MotionRecording_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__MotionRecording_GetResult_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MotionRecording_GetResult_Request_
{
  using Type = MotionRecording_GetResult_Request_<ContainerAllocator>;

  explicit MotionRecording_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit MotionRecording_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_GetResult_Request
    std::shared_ptr<kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_GetResult_Request
    std::shared_ptr<kompass_interfaces::action::MotionRecording_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionRecording_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionRecording_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionRecording_GetResult_Request_

// alias to use template instance with default allocator
using MotionRecording_GetResult_Request =
  kompass_interfaces::action::MotionRecording_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/motion_recording__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__MotionRecording_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__MotionRecording_GetResult_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MotionRecording_GetResult_Response_
{
  using Type = MotionRecording_GetResult_Response_<ContainerAllocator>;

  explicit MotionRecording_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit MotionRecording_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const kompass_interfaces::action::MotionRecording_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_GetResult_Response
    std::shared_ptr<kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_GetResult_Response
    std::shared_ptr<kompass_interfaces::action::MotionRecording_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionRecording_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionRecording_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionRecording_GetResult_Response_

// alias to use template instance with default allocator
using MotionRecording_GetResult_Response =
  kompass_interfaces::action::MotionRecording_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace action
{

struct MotionRecording_GetResult
{
  using Request = kompass_interfaces::action::MotionRecording_GetResult_Request;
  using Response = kompass_interfaces::action::MotionRecording_GetResult_Response;
};

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/motion_recording__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__MotionRecording_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__MotionRecording_FeedbackMessage __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MotionRecording_FeedbackMessage_
{
  using Type = MotionRecording_FeedbackMessage_<ContainerAllocator>;

  explicit MotionRecording_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit MotionRecording_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const kompass_interfaces::action::MotionRecording_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_FeedbackMessage
    std::shared_ptr<kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__MotionRecording_FeedbackMessage
    std::shared_ptr<kompass_interfaces::action::MotionRecording_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionRecording_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionRecording_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionRecording_FeedbackMessage_

// alias to use template instance with default allocator
using MotionRecording_FeedbackMessage =
  kompass_interfaces::action::MotionRecording_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace kompass_interfaces
{

namespace action
{

struct MotionRecording
{
  /// The goal message defined in the action definition.
  using Goal = kompass_interfaces::action::MotionRecording_Goal;
  /// The result message defined in the action definition.
  using Result = kompass_interfaces::action::MotionRecording_Result;
  /// The feedback message defined in the action definition.
  using Feedback = kompass_interfaces::action::MotionRecording_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = kompass_interfaces::action::MotionRecording_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = kompass_interfaces::action::MotionRecording_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = kompass_interfaces::action::MotionRecording_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct MotionRecording MotionRecording;

}  // namespace action

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__MOTION_RECORDING__STRUCT_HPP_
