// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:action/TrackVisionTarget.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__STRUCT_H_
#define KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'label'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/TrackVisionTarget in the package kompass_interfaces.
typedef struct kompass_interfaces__action__TrackVisionTarget_Goal
{
  rosidl_runtime_c__String label;
  double search_radius;
  double search_timeout;
} kompass_interfaces__action__TrackVisionTarget_Goal;

// Struct for a sequence of kompass_interfaces__action__TrackVisionTarget_Goal.
typedef struct kompass_interfaces__action__TrackVisionTarget_Goal__Sequence
{
  kompass_interfaces__action__TrackVisionTarget_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__TrackVisionTarget_Goal__Sequence;


// Constants defined in the message

/// Struct defined in action/TrackVisionTarget in the package kompass_interfaces.
typedef struct kompass_interfaces__action__TrackVisionTarget_Result
{
  /// False if the target is lost at the end of the action
  bool success;
  double tracked_duration;
} kompass_interfaces__action__TrackVisionTarget_Result;

// Struct for a sequence of kompass_interfaces__action__TrackVisionTarget_Result.
typedef struct kompass_interfaces__action__TrackVisionTarget_Result__Sequence
{
  kompass_interfaces__action__TrackVisionTarget_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__TrackVisionTarget_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'center_xy'
// Member 'size_xy'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in action/TrackVisionTarget in the package kompass_interfaces.
typedef struct kompass_interfaces__action__TrackVisionTarget_Feedback
{
  double score;
  rosidl_runtime_c__double__Sequence center_xy;
  rosidl_runtime_c__double__Sequence size_xy;
  double distance;
  double orientation;
} kompass_interfaces__action__TrackVisionTarget_Feedback;

// Struct for a sequence of kompass_interfaces__action__TrackVisionTarget_Feedback.
typedef struct kompass_interfaces__action__TrackVisionTarget_Feedback__Sequence
{
  kompass_interfaces__action__TrackVisionTarget_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__TrackVisionTarget_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "kompass_interfaces/action/detail/track_vision_target__struct.h"

/// Struct defined in action/TrackVisionTarget in the package kompass_interfaces.
typedef struct kompass_interfaces__action__TrackVisionTarget_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__TrackVisionTarget_Goal goal;
} kompass_interfaces__action__TrackVisionTarget_SendGoal_Request;

// Struct for a sequence of kompass_interfaces__action__TrackVisionTarget_SendGoal_Request.
typedef struct kompass_interfaces__action__TrackVisionTarget_SendGoal_Request__Sequence
{
  kompass_interfaces__action__TrackVisionTarget_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__TrackVisionTarget_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/TrackVisionTarget in the package kompass_interfaces.
typedef struct kompass_interfaces__action__TrackVisionTarget_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} kompass_interfaces__action__TrackVisionTarget_SendGoal_Response;

// Struct for a sequence of kompass_interfaces__action__TrackVisionTarget_SendGoal_Response.
typedef struct kompass_interfaces__action__TrackVisionTarget_SendGoal_Response__Sequence
{
  kompass_interfaces__action__TrackVisionTarget_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__TrackVisionTarget_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/TrackVisionTarget in the package kompass_interfaces.
typedef struct kompass_interfaces__action__TrackVisionTarget_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} kompass_interfaces__action__TrackVisionTarget_GetResult_Request;

// Struct for a sequence of kompass_interfaces__action__TrackVisionTarget_GetResult_Request.
typedef struct kompass_interfaces__action__TrackVisionTarget_GetResult_Request__Sequence
{
  kompass_interfaces__action__TrackVisionTarget_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__TrackVisionTarget_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/track_vision_target__struct.h"

/// Struct defined in action/TrackVisionTarget in the package kompass_interfaces.
typedef struct kompass_interfaces__action__TrackVisionTarget_GetResult_Response
{
  int8_t status;
  kompass_interfaces__action__TrackVisionTarget_Result result;
} kompass_interfaces__action__TrackVisionTarget_GetResult_Response;

// Struct for a sequence of kompass_interfaces__action__TrackVisionTarget_GetResult_Response.
typedef struct kompass_interfaces__action__TrackVisionTarget_GetResult_Response__Sequence
{
  kompass_interfaces__action__TrackVisionTarget_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__TrackVisionTarget_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/track_vision_target__struct.h"

/// Struct defined in action/TrackVisionTarget in the package kompass_interfaces.
typedef struct kompass_interfaces__action__TrackVisionTarget_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  kompass_interfaces__action__TrackVisionTarget_Feedback feedback;
} kompass_interfaces__action__TrackVisionTarget_FeedbackMessage;

// Struct for a sequence of kompass_interfaces__action__TrackVisionTarget_FeedbackMessage.
typedef struct kompass_interfaces__action__TrackVisionTarget_FeedbackMessage__Sequence
{
  kompass_interfaces__action__TrackVisionTarget_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__action__TrackVisionTarget_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_VISION_TARGET__STRUCT_H_
