// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:srv/PlanPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__TRAITS_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/srv/detail/plan_path__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'start'
// Member 'goal'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const PlanPath_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: start
  {
    out << "start: ";
    to_flow_style_yaml(msg.start, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
    out << ", ";
  }

  // member: from_robot_pose
  {
    out << "from_robot_pose: ";
    rosidl_generator_traits::value_to_yaml(msg.from_robot_pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: start
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start:\n";
    to_block_style_yaml(msg.start, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }

  // member: from_robot_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "from_robot_pose: ";
    rosidl_generator_traits::value_to_yaml(msg.from_robot_pose, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::PlanPath_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::PlanPath_Request & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::PlanPath_Request>()
{
  return "kompass_interfaces::srv::PlanPath_Request";
}

template<>
inline const char * name<kompass_interfaces::srv::PlanPath_Request>()
{
  return "kompass_interfaces/srv/PlanPath_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::PlanPath_Request>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Pose>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::PlanPath_Request>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Pose>::value> {};

template<>
struct is_message<kompass_interfaces::srv::PlanPath_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'plan'
#include "nav_msgs/msg/detail/path__traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const PlanPath_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: plan
  {
    out << "plan: ";
    to_flow_style_yaml(msg.plan, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanPath_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: plan
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "plan:\n";
    to_block_style_yaml(msg.plan, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanPath_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::PlanPath_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::PlanPath_Response & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::PlanPath_Response>()
{
  return "kompass_interfaces::srv::PlanPath_Response";
}

template<>
inline const char * name<kompass_interfaces::srv::PlanPath_Response>()
{
  return "kompass_interfaces/srv/PlanPath_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::PlanPath_Response>
  : std::integral_constant<bool, has_fixed_size<nav_msgs::msg::Path>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::PlanPath_Response>
  : std::integral_constant<bool, has_bounded_size<nav_msgs::msg::Path>::value> {};

template<>
struct is_message<kompass_interfaces::srv::PlanPath_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::PlanPath>()
{
  return "kompass_interfaces::srv::PlanPath";
}

template<>
inline const char * name<kompass_interfaces::srv::PlanPath>()
{
  return "kompass_interfaces/srv/PlanPath";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::PlanPath>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::srv::PlanPath_Request>::value &&
    has_fixed_size<kompass_interfaces::srv::PlanPath_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::srv::PlanPath>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::srv::PlanPath_Request>::value &&
    has_bounded_size<kompass_interfaces::srv::PlanPath_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::srv::PlanPath>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::srv::PlanPath_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::srv::PlanPath_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__TRAITS_HPP_
