// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:srv/StartPathRecording.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__TRAITS_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/srv/detail/start_path_recording__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StartPathRecording_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: recording_time_step
  {
    out << "recording_time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_time_step, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StartPathRecording_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: recording_time_step
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "recording_time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.recording_time_step, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StartPathRecording_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::StartPathRecording_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::StartPathRecording_Request & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::StartPathRecording_Request>()
{
  return "kompass_interfaces::srv::StartPathRecording_Request";
}

template<>
inline const char * name<kompass_interfaces::srv::StartPathRecording_Request>()
{
  return "kompass_interfaces/srv/StartPathRecording_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StartPathRecording_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::StartPathRecording_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<kompass_interfaces::srv::StartPathRecording_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StartPathRecording_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: started_recording
  {
    out << "started_recording: ";
    rosidl_generator_traits::value_to_yaml(msg.started_recording, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StartPathRecording_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: started_recording
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "started_recording: ";
    rosidl_generator_traits::value_to_yaml(msg.started_recording, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StartPathRecording_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::StartPathRecording_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::StartPathRecording_Response & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::StartPathRecording_Response>()
{
  return "kompass_interfaces::srv::StartPathRecording_Response";
}

template<>
inline const char * name<kompass_interfaces::srv::StartPathRecording_Response>()
{
  return "kompass_interfaces/srv/StartPathRecording_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StartPathRecording_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::StartPathRecording_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::srv::StartPathRecording_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::StartPathRecording>()
{
  return "kompass_interfaces::srv::StartPathRecording";
}

template<>
inline const char * name<kompass_interfaces::srv::StartPathRecording>()
{
  return "kompass_interfaces/srv/StartPathRecording";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::StartPathRecording>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::srv::StartPathRecording_Request>::value &&
    has_fixed_size<kompass_interfaces::srv::StartPathRecording_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::srv::StartPathRecording>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::srv::StartPathRecording_Request>::value &&
    has_bounded_size<kompass_interfaces::srv::StartPathRecording_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::srv::StartPathRecording>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::srv::StartPathRecording_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::srv::StartPathRecording_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__START_PATH_RECORDING__TRAITS_HPP_
